<?php
/*---------------------------------------------------------------*/
/*
    Titre : Composantes d'une image                                                                                       
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=983
    Date dition     : 15 Fv 2019                                                                                        
*/
/*---------------------------------------------------------------*/

 function composantes($src , $dest , $format , $comp){
 /* Paramtres : $src : fichier source 
  * $dest : fichier de destination 
  * $format : format de l'image rsultat 
  * ("GIF", "JPG", "PNG", "WBMP") 
  * $comp : chaines des composantes a garder : 
  * 'r' pour le rouge, 'bg' ou 'gb' pour bleu et vert 
  * 'rgb', 'gbr'... pour les trois 
  */ 
  
  $comp = strtolower($comp); 
  $comps = $chars = preg_split('//', $comp, -1, PREG_SPLIT_NO_EMPTY); 
  
  if (file_exists($src)) 
  $size = getimagesize($src); 
  else 
  return FALSE; 
  
  switch($size[2]) 
  { 
  case 1 : 
  if (imagetypes() & IMG_GIF) 
  $pic = imagecreatefromgif($src); 
  break; 
  case 2 : 
  if (imagetypes() & IMG_JPG) 
  $pic = imagecreatefromjpeg($src); 
  break; 
  case 3 : 
  if (imagetypes() & IMG_PNG) 
  $pic = imagecreatefrompng($src); 
  break; 
  default : 
  if (preg_match("/\.wbmp$/i", $src) && (imagetypes() & IMG_WBMP)) 
  $pic = imagecreatefromwbmp($src); 
  } 
  if (!$pic) 
  return FALSE; 
  
  $colors_num = imagecolorstotal($pic); 
  
  for($i=0;$i<$colors_num;$i++) 
  { 
  $color = imagecolorsforindex($pic, $i); 
  $r = $color["red"]; 
  $g = $color["green"]; 
  $b = $color["blue"]; 
  
  if (!in_array('r', $comps)) 
  $r=0; 
  if (!in_array('g', $comps)) 
  $g=0; 
  if (!in_array('b', $comps)) 
  $b=0; 
  imagecolorset($pic, $i, $r, $g, $b); 
  } 
  
  $format = strtoupper($format); 
  if ($format == "GIF") 
  { 
  if (imagetypes() & IMG_GIF) 
  imagegif($pic, $dest); 
  else 
  return FALSE; 
  } 
  else if ($format == "JPG") 
  { 
  if (imagetypes() & IMG_JPG) 
  imagejpeg($pic, $dest); 
  else 
  return FALSE; 
  } 
  else if ($format == "PNG") 
  { 
  if (imagetypes() & IMG_PNG) 
  imagepng($pic, $dest); 
  else 
  return FALSE; 
  } 
  else if ($format == "WBMP") 
  { 
  if (imagetypes() & IMG_WBMP) 
  imagewbmp($pic, $dest); 
  else 
  return FALSE; 
  } 
  else return FALSE; 
  return TRUE; 
}

?>